#include "colorselector.h"
#include "ui_colorselector.h"
#include <qdebug.h>

/*! Constructor of ColorSelector.*/
ColorSelector::ColorSelector(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::ColorSelector) {
    ui->setupUi(this);
    ui->labelDefault->setPixmap(QPixmap("icons/atm.jpg").scaled(200, 100));
    ui->labelVariation->setPixmap(QPixmap("icons/ami.jpg").scaled(200, 100));
    ui->labelBlackWhite->setPixmap(QPixmap("icons/res.jpg").scaled(200, 100));
    ui->labelElevation->setPixmap(QPixmap("icons/bar.jpg").scaled(200, 100));
    ui->labelDistSG->setPixmap(QPixmap("icons/sg.jpg").scaled(200, 100));
    ui->labelTemp->setPixmap(QPixmap("icons/temp.jpg").scaled(200, 100));
    ui->labelHydro->setPixmap(QPixmap("icons/hyd.jpg").scaled(200, 100));
    ui->labelBS->setPixmap(QPixmap("icons/bs.jpg").scaled(200, 100));
    ui->labelCon->setPixmap(QPixmap("icons/co.jpg").scaled(200, 100));

    ui->radioButtonDefault->setChecked(true);
}

/*! Destructor of ColorSelector.*/
ColorSelector::~ColorSelector() {
    delete ui;
}

void ColorSelector::on_buttonBox_accepted() {
    emit changeColor(colorSelection);
}

void ColorSelector::on_buttonBox_rejected() {

}

void ColorSelector::on_radioButtonDefault_clicked() {
    colorSelection = 0;
}

void ColorSelector::on_radioButtonVariation_clicked() {
    colorSelection = 1;
}

void ColorSelector::on_radioButtonBlackWhite_clicked() {
    colorSelection = 2;
}

void ColorSelector::on_radioButtonElevation_clicked() {
    colorSelection = 3;
}

void ColorSelector::on_radioButtonDistSG_clicked() {
    colorSelection = 4;
}

void ColorSelector::on_radioButtonTemp_clicked() {
    colorSelection = 6;
}

void ColorSelector::on_radioButtonHydro_clicked() {
    colorSelection = 7;
}

void ColorSelector::on_radioButtonBS_clicked() {
    colorSelection = 9;
}

void ColorSelector::on_radioButtonCon_clicked() {
    colorSelection = 10;
}

void ColorSelector::on_comboBox_currentIndexChanged(int index) {
    ui->stackedWidget->setCurrentIndex(index);
    if(index == 0){
        ui->radioButtonDefault->setChecked(true);
        colorSelection = 0;
    }else if(index == 1){
        ui->radioButtonElevation->setChecked(true);
        colorSelection = 3;
    }else if(index == 2){
        ui->radioButtonTemp->setChecked(true);
        colorSelection = 6;
    }else if(index == 3){
        ui->radioButtonBS->setChecked(true);
        colorSelection = 9;
    }
}
