#ifndef COLORSELECTOR_H
#define COLORSELECTOR_H

#include <QDialog>

namespace Ui {
class ColorSelector;
}

/*! This is the class which makes it possible to select between different colors. */
class ColorSelector : public QDialog
{
    Q_OBJECT

public:
    explicit ColorSelector(QWidget *parent = 0);
    ~ColorSelector();

signals:
    void changeColor(int colorSelection);

private slots:
    void on_buttonBox_accepted();
    void on_buttonBox_rejected();
    void on_comboBox_currentIndexChanged(int index);

    void on_radioButtonDefault_clicked();
    void on_radioButtonVariation_clicked();
    void on_radioButtonBlackWhite_clicked();
    void on_radioButtonElevation_clicked();
    void on_radioButtonDistSG_clicked();
    void on_radioButtonTemp_clicked();
    void on_radioButtonHydro_clicked();
    void on_radioButtonBS_clicked();

    void on_radioButtonCon_clicked();

private:
    Ui::ColorSelector *ui;
    int colorSelection = 0;
};

#endif // COLORSELECTOR_H
