#include "shader.h"

shader::shader(QString vsFileName, QString fsFileName) :
  vsFileName(vsFileName), fsFileName(fsFileName)
{
  if(!shaderProgram.addShaderFromSourceFile(QOpenGLShader::Vertex, vsFileName) ||
     !shaderProgram.addShaderFromSourceFile(QOpenGLShader::Fragment, fsFileName) ||
     !shaderProgram.link())
  {
    qDebug() << shaderProgram.log();
  }
}

shader::shader(QString vsFileName, QString gsFileName, QString fsFileName)
{
    if(!shaderProgram.addShaderFromSourceFile(QOpenGLShader::Vertex, vsFileName) ||
       !shaderProgram.addShaderFromSourceFile(QOpenGLShader::Geometry, gsFileName) ||
       !shaderProgram.addShaderFromSourceFile(QOpenGLShader::Fragment, fsFileName) ||
       !shaderProgram.link())
    {
      qDebug() << shaderProgram.log();
    }
}

QOpenGLShaderProgram *shader::getShaderProgramm()
{
  return &shaderProgram;
}
