#version 330
in vec3 fragmentPosition;
in vec3 fragmentNormal;
in vec3 fragmentColor;
in vec3 worldPosition;
in vec3 worldNormal;

out vec4 color;

mat4 modelMatrix = mat4(1.0);
uniform mat4 viewMatrix;
uniform mat4 projectionMatrix;
uniform int renderMode;

vec3 lightPosition = vec3(500.0, 500.0, -500.0);

void main() {
    vec3 normal = normalize(worldNormal.xyz);
    vec3 lightDirection = normalize(lightPosition - worldPosition.xyz);

    float ambientStrength = 0.1;
    if(renderMode != 1) ambientStrength = 0.5;
    vec3 ambient = ambientStrength * vec3(1.0, 1.0, 1.0);

    float diffuseCoefficient = max(dot(normal, lightDirection), 0.0);
    vec3 diffuse = diffuseCoefficient * vec3(1.0, 1.0, 1.0);

    vec3 result = vec3(ambient + diffuse) * fragmentColor;
    color = vec4(result, 1);
}
