#version 330
layout(location = 0) in vec3 vertexPosition;
layout(location = 1) in vec3 vertexNormal;
layout(location = 2) in vec3 vertexColor;

out vec3 fragmentPosition;
out vec3 fragmentNormal;
out vec3 fragmentColor;
out vec3 worldPosition;
out vec3 worldNormal;

uniform mat4 modelMatrix;
uniform mat4 projectionMatrix;
uniform mat4 viewMatrix;

void main() {
    fragmentPosition = vertexPosition;
    fragmentNormal = vertexNormal;
    fragmentColor = vertexColor;
    worldPosition = vec3(modelMatrix * vec4(vertexPosition, 1));
    worldNormal = vec3(modelMatrix * vec4(vertexNormal, 0));
    gl_Position = projectionMatrix * viewMatrix * modelMatrix * vec4(vertexPosition, 1);
}
