#version 400

layout(triangles) in;
layout(triangle_strip, max_vertices = 6) out;

in VS_OUT {
    vec3 color;
} gs_in[];

out vec3 c;

vec4 mirror(vec4 v){
    if(v.x > 0.0f){
        float amount = 1.0f - v.x;
        return vec4(-1.0f - amount, v.yzw);
    }if(v.x < 0.0f){
        float amount = 1.0f + v.x;
        return vec4(1.0f + amount, v.yzw);
    }
}

bool exceedMeridian(vec4 v1, vec4 v2){

    return ( abs((v1.x + 1.0f) - (v2.x + 1.0f)) >= 1.0f );
}

void main()
{
    vec4 v0 = gl_in[0].gl_Position;
    vec4 v1 = gl_in[1].gl_Position;
    vec4 v2 = gl_in[2].gl_Position;

    if(exceedMeridian(v0, v1) && exceedMeridian(v1, v2)){
        gl_Position = v0;
        c = gs_in[0].color;
        EmitVertex();

        gl_Position = mirror(v1);
        c = gs_in[1].color;
        EmitVertex();

        gl_Position = v2;
        c = gs_in[2].color;
        EmitVertex();

        EndPrimitive();

        gl_Position = mirror(v0);
        c = gs_in[0].color;
        EmitVertex();

        gl_Position = v1;
        c = gs_in[1].color;
        EmitVertex();

        gl_Position = mirror(v2);
        c = gs_in[2].color;
        EmitVertex();

        EndPrimitive();

    }else if(exceedMeridian(v0, v1) && exceedMeridian(v2, v0)){

        gl_Position = mirror(v0);
        c = gs_in[0].color;
        EmitVertex();

        gl_Position = v1;
        c = gs_in[1].color;
        EmitVertex();

        gl_Position = v2;
        c = gs_in[2].color;
        EmitVertex();

        EndPrimitive();

        gl_Position = v0;
        c = gs_in[0].color;
        EmitVertex();

        gl_Position = mirror(v1);
        c = gs_in[1].color;
        EmitVertex();

        gl_Position = mirror(v2);
        c = gs_in[2].color;
        EmitVertex();

        EndPrimitive();
    } else if(exceedMeridian(v1, v2) && exceedMeridian(v0, v2)){
        gl_Position = v0;
        c = gs_in[0].color;
        EmitVertex();

        gl_Position = v1;
        c = gs_in[1].color;
        EmitVertex();

        gl_Position = mirror(v2);
        c = gs_in[2].color;
        EmitVertex();

        EndPrimitive();

        gl_Position = mirror(v0);
        c = gs_in[0].color;
        EmitVertex();

        gl_Position = mirror(v1);
        c = gs_in[1].color;
        EmitVertex();

        gl_Position = v2;
        c = gs_in[2].color;
        EmitVertex();

        EndPrimitive();
    }else{
        gl_Position = v0;
        c = gs_in[0].color;
        EmitVertex();

        gl_Position = v1;
        c = gs_in[1].color;
        EmitVertex();

        gl_Position = v2;
        c = gs_in[2].color;
        EmitVertex();

        EndPrimitive();
    }
}
