#include "spheremap.h"

SphereMap::SphereMap()
{
}

void SphereMap::init(QOpenGLExtraFunctions *gl)
{
    _gl = gl;
}


void SphereMap::setSphere(SurfaceMeshSphere *sphere)
{
    _sphere = sphere;

    _gl->glGenVertexArrays(1, &vao);


    QOpenGLBuffer verBufBuf(QOpenGLBuffer::VertexBuffer);
    verBufBuf.create();
    verBuf = verBufBuf;
    verBuf.bind();
    verBuf.allocate(
        this->_sphere->getVerticesSphere()->data(),
        static_cast<int>(this->_sphere->getVerticesSphere()->size()) * sizeof(QVector3D));

    // color
    colorBuf.create();
    colorBuf.bind();
    colorBuf.allocate(
         this->_sphere->getColors()->data(),
        static_cast<int>(this->_sphere->getColors()->size()) * sizeof(QVector3D));

    // normal
    normalBuf.create();
    normalBuf.bind();
    normalBuf.allocate(
         this->_sphere->getNormalsSphere()->data(),
        static_cast<int>(this->_sphere->getNormalsSphere()->size()) * sizeof(QVector3D));


    // index
    QOpenGLBuffer idxBufBuf(QOpenGLBuffer::IndexBuffer);
    idxBufBuf.create();
    idxBuf = idxBufBuf;
    idxBuf.bind();
    idxBuf.allocate(
        this->_sphere->getIndices()->data(),
        static_cast<int>(this->_sphere->getIndices()->size()) * sizeof(GLuint));
}


void SphereMap::draw()
{

    // bind
    _gl->glBindVertexArray(vao);

    _gl->glEnableVertexAttribArray(0);
    verBuf.bind();
    _gl->glVertexAttribPointer(0, 3, GL_FLOAT, GL_FALSE, 0, 0);

    _gl->glEnableVertexAttribArray(1);
    normalBuf.bind();
    _gl->glVertexAttribPointer(1, 3, GL_FLOAT, GL_FALSE, 0, 0);

    _gl->glEnableVertexAttribArray(2);
    colorBuf.bind();
    _gl->glVertexAttribPointer(2, 3, GL_FLOAT, GL_FALSE, 0, 0);

    idxBuf.bind();

    // draw
     _gl->glDrawElements(GL_TRIANGLES, this->_sphere->getIndices()->size(), GL_UNSIGNED_INT, 0);

    // unbind
    _gl->glDisableVertexAttribArray(0);
    _gl->glDisableVertexAttribArray(1);
    _gl->glDisableVertexAttribArray(2);

    _gl->glBindVertexArray(0);
}
