#ifndef SPHEREMAP_H
#define SPHEREMAP_H

#include <QOpenGLExtraFunctions>
#include <QOpenGLFramebufferObject>
#include <QOpenGLFunctions>
#include <QOpenGLTexture>
#include <QOpenGLBuffer>
#include <QVector>
#include <QVector3D>

#include "../meshsphereview/surfacemeshsphere.h"

/*! Creates a map and renders it from a SurfaceMeshSphere as input. */

class SphereMap
{
public:
    SphereMap();

    void init(QOpenGLExtraFunctions *gl);
    void setSphere(SurfaceMeshSphere *sphere);
    void draw();

private:
    QOpenGLExtraFunctions *_gl = NULL;

    SurfaceMeshSphere *_sphere;

    bool loaded = false;

    GLuint vao;
    QOpenGLBuffer verBuf, idxBuf, colorBuf, normalBuf;
};

#endif // SPHEREMAP_H
