#ifndef TEXTUREVIEW_H
#define TEXTUREVIEW_H

#include <QMatrix4x4>
#include <QOpenGLFramebufferObject>
#include <QOpenGLFunctions>
#include <QOpenGLWidget>
#include <QQuaternion>
#include <QVector2D>

#include "shader.h"
#include "spheremap.h"
#include "../meshsphereview/surfacemeshsphere.h"

/*! This is the class which powers the view that shows the unwraped sphere texture. */

class textureView : public QOpenGLWidget, protected QOpenGLFunctions
{
    Q_OBJECT
public:
    textureView(QWidget* parent = nullptr);

protected:
    void initializeGL() override;
    void paintGL() override;

private:
    QOpenGLExtraFunctions *_gl = NULL;

    SurfaceMeshSphere *_sphere = NULL;

    SphereMap sm;
    shader *sphereMapShader;

private slots:
    void surfaceMeshSphereChanged(SurfaceMeshSphere *newSurfaceMeshSphere); //!< When a new mesh is loaded, it is send to this view.
};

#endif // TEXTUREVIEW_H
